export P=msodbcsql
export MAINTAINER=JuergenFischer
export B=1

set -e

[ -n "$OSGEO4W_REP" -a -d "$OSGEO4W_REP" ] || { echo OSGEO4W_REP not set; exit 1; }

[ -f msodbcsql-x86_64.msi ] || wget -q -c -O $P-x86_64.msi "https://download.microsoft.com/download/5/7/2/57249A3A-19D6-4901-ACCE-80924ABEB267/ENU/x64/msodbcsql.msi"
[ -f msodbcsql-x86.msi ] || wget -q -c -O $P-x86.msi "https://download.microsoft.com/download/5/7/2/57249A3A-19D6-4901-ACCE-80924ABEB267/ENU/x86/msodbcsql.msi"

mkdir -p extract
msiexec /a $P-x86_64.msi /qb "TARGETDIR=$(cygpath -aw extract)"

for a in x86 x86_64; do
	case "$a" in
	x86)
		lib=lib/x86
		;;

	x86_64)
		lib=lib/x64
		;;
	esac

	path=$(echo "extract/Program Files/Microsoft SQL Server/Client SDK/ODBC/"*)
	v=${path##*/}

	major=${v%?}
	minor=${v#$major}
	V=$major.$minor

	export R=$OSGEO4W_REP/$a/release/$P
	mkdir -p $R/$P-devel

	cat <<EOF >$R/setup.hint
sdesc: "Microsoft ODBC Driver for SQL Server (runtime)"
ldesc: "Microsoft ODBC Driver for SQL Server (runtime)"
category: Libs
requires: msvcrt2019
maintainer: $MAINTAINER
EOF

	cp "extract/Program Files/Microsoft SQL Server/Client SDK/ODBC/$v/License Terms/License_msodbcsql_ENU.txt" $R/$P-devel/$P-devel-$V-$B.txt

	cat <<EOF >$R/$P-devel/setup.hint
sdesc: "Microsoft ODBC Driver for SQL Server (Development)"
ldesc: "Microsoft ODBC Driver for SQL Server (Development)"
category: Libs
requires: $P
external-source: $P
maintainer: $MAINTAINER
EOF

	cat <<EOF >postinstall.bat
msiexec /i %OSGEO4W_ROOT%\\bin\\$P.msi /qn IACCEPTMSOLEDBSQLLICENSETERMS=YES
EOF

	tar -cjf $R/$P-$V-$B.tar.bz2 \
		--xform "s,postinstall.bat,etc/postinstall/$P.bat," \
		--xform "s,$P-$a.msi,bin/$P.msi," \
		postinstall.bat \
		$P-$a.msi

	tar -C "$path/SDK" -cjf $R/$P-devel/$P-devel-$V-$B.tar.bz2 \
		--xform "s,$lib,lib," \
		Include/msodbcsql.h \
		$lib/msodbcsql$major.lib \

	tar -C .. -cjf $R/$P-$V-$B-src.tar.bz2 osgeo4w/package.sh
done
